package org.amoth.GUI;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.amoth.action.Action;

public abstract class Screen {

	protected List<Action> actionList;

	public Screen display() {
		// clean screen
		this.actionList = new ArrayList<Action>();
		this.buildActionList();
		for (int i = 0; i < 5; i++) {
			System.out
					.println("\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n");
		}
		System.out.println("    PRS-T1 tweak version 1.0");
		System.out.println("--------------------------------");
		System.out.println(this.getTitle());
		System.out.println("\r\n");
		System.out.println(this.getComment());
		System.out.println("\r\n");
		for (Action item : this.getActionList()) {
			System.out.println("    " + item.getCode() + ": "
					+ item.getDescription() + "\r\n");
		}
		System.out.println("    ----\r\n");
		System.out.println("    menu: go to Main menu (more options)\r\n");
		System.out.println("    quit: quit this application\r\n\r\n");
		System.out.print(this.getPromp());
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String result = "";

		try {
			result = br.readLine();
		} catch (IOException ioe) {
			System.out.println("IO error");
			System.exit(1);
		}
		if (result.toLowerCase().startsWith("quit")) {
			System.out.println("Bye Bye");
			return null;
		}
		if (result.toLowerCase().startsWith("menu"))
			return new CreateOrOpenScreen();
		for (Action action : this.actionList) {
			if (result.toLowerCase().startsWith(action.getCode().toLowerCase()))
				return action.run();
		}
		return this;
	}

	protected abstract void buildActionList();

	protected List<Action> getActionList() {
		return this.actionList;
	}

	protected abstract String getTitle();

	protected abstract String getComment();

	protected abstract String getPromp();
}
