package org.amoth.business;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class DBRequest {

	public void executeRequest(String drive, String request) {
		try {
			Class.forName("org.sqlite.JDBC");
		} catch (ClassNotFoundException e1) {
		}

		Connection connection = null;
		try {
			// create a database connection
			connection = DriverManager.getConnection("jdbc:sqlite:" + drive
					+ ":\\Sony_Reader\\database\\books.db");
			Statement statement = connection.createStatement();
			statement.setQueryTimeout(30); // set timeout to 30 sec.

			statement.executeUpdate(request);

		} catch (SQLException e) {
			System.err.println(e.getMessage());
		} finally {
			try {
				if (connection != null)
					connection.close();
			} catch (SQLException e) {
				// connection close failed.
				System.err.println(e);
			}
		}
	}

	public String getCount(String drive, String request) {
		try {
			Class.forName("org.sqlite.JDBC");
		} catch (ClassNotFoundException e1) {
		}

		Connection connection = null;
		String result = "";
		try {
			// create a database connection
			connection = DriverManager.getConnection("jdbc:sqlite:" + drive
					+ ":\\Sony_Reader\\database\\books.db");
			Statement statement = connection.createStatement();
			statement.setQueryTimeout(30); // set timeout to 30 sec.

			ResultSet rs = statement.executeQuery(request);
			rs.next();
			result = rs.getString("count");

		} catch (SQLException e) {
			System.err.println(e.getMessage());
		} finally {
			try {
				if (connection != null)
					connection.close();
			} catch (SQLException e) {
				System.err.println(e);
			}
		}
		return result;
	}

	public void activateRecentlyRead(String letterDrive) {
		this.executeRequest(
				letterDrive,
				"UPDATE books SET added_date = reading_time WHERE reading_time NOT NULL AND added_date <> reading_time;");
		this.executeRequest(
				letterDrive,
				"UPDATE books SET added_date = 0 WHERE reading_time = (select max(reading_time) from books);");
		this.executeRequest(
				letterDrive,
				"CREATE TRIGGER recently_opened_trigger AFTER UPDATE OF reading_time ON books "
						+ "BEGIN "
						+ "UPDATE books SET added_date = 0 WHERE _id = new._id; "
						+ "UPDATE books SET added_date = reading_time WHERE reading_time NOT NULL AND added_date <> reading_time AND _id <> new._id; "
						+ "END;");
	}

	public void unactivateRecentlyRead(String letterDrive) {
		this.executeRequest(letterDrive,
				"DROP TRIGGER recently_opened_trigger;");
	}

	public void activateAutoCollection(String letterDrive) {
		this.executeRequest(
				letterDrive,
				"INSERT INTO collection (title, source_id) "
						+ "SELECT substr(file_path, 0, length(file_path) - length(file_name)), 0  "
						+ "FROM books  "
						+ "LEFT join collection ON collection.title = (substr(file_path, 0, length(file_path) - length(file_name))) "
						+ "WHERE collection.title is null "
						+ "GROUP BY substr(file_path, 0, length(file_path) - length(file_name)) "
						+ ";");
		this.executeRequest(
				letterDrive,
				"INSERT into collections (collection_id, content_id) "
						+ "SELECT collection._id, books._id "
						+ "FROM books "
						+ "JOIN collection ON (collection.title = (substr(file_path, 0, length(file_path) - length(file_name))))   "
						+ "LEFT JOIN collections ON (collections.collection_id = collection._id AND collections.content_id = books._id) "
						+ "WHERE (collection.title = substr(file_path, 0, length(file_path) - length(file_name))) and collections.collection_id IS NULL "
						+ ";");
		this.executeRequest(
				letterDrive,
				"CREATE TRIGGER autoCreateCollection AFTER INSERT ON books "
						+ "BEGIN "
						+ "insert into collection (title, source_id)  "
						+ "SELECT substr(NEW.file_path, 0, length(NEW.file_path) - length(NEW.file_name)), 0  "
						+ "FROM android_metadata  "
						+ "LEFT join collection ON title = (substr(NEW.file_path, 0, length(NEW.file_path) - length(NEW.file_name)))  "
						+ "WHERE collection.title is null "
						+ "; "
						+ "INSERT into collections (collection_id, content_id)  "
						+ "SELECT collection._id, NEW._id  "
						+ "FROM collection   "
						+ "LEFT JOIN collections ON (collections.collection_id = collection._id AND collections.content_id = NEW._id) "
						+ "WHERE (title = substr(NEW.file_path, 0, length(NEW.file_path) - length(NEW.file_name))) and collections.collection_id IS NULL "
						+ "; " + "END;");
	}

	public void unactivateAutoCollection(String letterDrive) {
		this.executeRequest(letterDrive, "DROP TRIGGER autoCreateCollection;");
		this.executeRequest(
				letterDrive,
				"DELETE FROM collection WHERE title IN (SELECT substr(file_path, 0, length(file_path) - length(file_name)) FROM BOOKS) ");
	}

	public boolean isRecentlyReadActive(String letterDrive) {
		return this
				.getCount(
						letterDrive,
						"SELECT count(*) as count FROM sqlite_master where name = 'recently_opened_trigger'")
				.equals("1");
	}

	public boolean isAutoCollectionActive(String letterDrive) {
		return this
				.getCount(
						letterDrive,
						"SELECT count(*) as count FROM sqlite_master where name = 'autoCreateCollection'")
				.equals("1");
	}
}
